/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-groovy-posedetection-msgs-1.0.40-0quantal-20140920-0129/srv/Detect.srv
 *
 */


#ifndef POSEDETECTION_MSGS_MESSAGE_DETECTRESPONSE_H
#define POSEDETECTION_MSGS_MESSAGE_DETECTRESPONSE_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <posedetection_msgs/ObjectDetection.h>

namespace posedetection_msgs
{
template <class ContainerAllocator>
struct DetectResponse_
{
  typedef DetectResponse_<ContainerAllocator> Type;

  DetectResponse_()
    : object_detection()  {
    }
  DetectResponse_(const ContainerAllocator& _alloc)
    : object_detection(_alloc)  {
    }



   typedef  ::posedetection_msgs::ObjectDetection_<ContainerAllocator>  _object_detection_type;
  _object_detection_type object_detection;




  typedef boost::shared_ptr< ::posedetection_msgs::DetectResponse_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::posedetection_msgs::DetectResponse_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct DetectResponse_

typedef ::posedetection_msgs::DetectResponse_<std::allocator<void> > DetectResponse;

typedef boost::shared_ptr< ::posedetection_msgs::DetectResponse > DetectResponsePtr;
typedef boost::shared_ptr< ::posedetection_msgs::DetectResponse const> DetectResponseConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::posedetection_msgs::DetectResponse_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::posedetection_msgs::DetectResponse_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace posedetection_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'sensor_msgs': ['/opt/ros/groovy/share/sensor_msgs/cmake/../msg'], 'std_msgs': ['/opt/ros/groovy/share/std_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/groovy/share/geometry_msgs/cmake/../msg'], 'posedetection_msgs': ['/tmp/buildd/ros-groovy-posedetection-msgs-1.0.40-0quantal-20140920-0129/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::posedetection_msgs::DetectResponse_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::posedetection_msgs::DetectResponse_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::posedetection_msgs::DetectResponse_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::posedetection_msgs::DetectResponse_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::posedetection_msgs::DetectResponse_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::posedetection_msgs::DetectResponse_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::posedetection_msgs::DetectResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "dfda508003c9f196a1244a8220042d0c";
  }

  static const char* value(const ::posedetection_msgs::DetectResponse_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xdfda508003c9f196ULL;
  static const uint64_t static_value2 = 0xa1244a8220042d0cULL;
};

template<class ContainerAllocator>
struct DataType< ::posedetection_msgs::DetectResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "posedetection_msgs/DetectResponse";
  }

  static const char* value(const ::posedetection_msgs::DetectResponse_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::posedetection_msgs::DetectResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "ObjectDetection object_detection\n\
\n\
\n\
================================================================================\n\
MSG: posedetection_msgs/ObjectDetection\n\
Header header\n\
Object6DPose[] objects\n\
# unique image id these objects were taken from\n\
\n\
================================================================================\n\
MSG: std_msgs/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.secs: seconds (stamp_secs) since epoch\n\
# * stamp.nsecs: nanoseconds since stamp_secs\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
\n\
================================================================================\n\
MSG: posedetection_msgs/Object6DPose\n\
# 6D pose of object\n\
geometry_msgs/Pose pose\n\
\n\
# type of object, usually contains the filename of the object that allows the receiving side to visualize it\n\
# can also be used as a unique type id\n\
string type \n\
\n\
================================================================================\n\
MSG: geometry_msgs/Pose\n\
# A representation of pose in free space, composed of postion and orientation. \n\
Point position\n\
Quaternion orientation\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Point\n\
# This contains the position of a point in free space\n\
float64 x\n\
float64 y\n\
float64 z\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Quaternion\n\
# This represents an orientation in free space in quaternion form.\n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
float64 w\n\
";
  }

  static const char* value(const ::posedetection_msgs::DetectResponse_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::posedetection_msgs::DetectResponse_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.object_detection);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct DetectResponse_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::posedetection_msgs::DetectResponse_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::posedetection_msgs::DetectResponse_<ContainerAllocator>& v)
  {
    s << indent << "object_detection: ";
    s << std::endl;
    Printer< ::posedetection_msgs::ObjectDetection_<ContainerAllocator> >::stream(s, indent + "  ", v.object_detection);
  }
};

} // namespace message_operations
} // namespace ros

#endif // POSEDETECTION_MSGS_MESSAGE_DETECTRESPONSE_H
